//@ts-check
"use strict";

/**
@typedef Interactive
@type {{
  kind: "item" | "npc",
  id: string,
}}
 */

/** @param {number} dt */
function updateInteractives(dt) {
  const { items, npcs } = inGame.activeWorld;

  let maxDist = 2;

  /** @type {Interactive} */
  let best;
  /** @type {number} */
  let bestDist = Infinity;

  {
    for (const item of items) {
      let dist = distxy(item.pos, inGame.baxton.pos);
      if (dist < maxDist) {
        if (dist < bestDist) {
          bestDist = dist;
          best = { kind: "item", id: item.id };
        }
      }
    }
  }

  for (const npc of npcs) {
    if (npc.desc.uncounted) {
      continue;
    }

    let dist = distxy(npc.pos, inGame.baxton.pos);
    if (dist < maxDist) {
      if (dist < bestDist) {
        bestDist = dist;
        best = { kind: "npc", id: npc.id };
      }
    }
  }

  inGame.stats.hovered = best;
}
